<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  	<title>Quick Planes Battle</title>
	<link href="main.css" type="text/css" rel="stylesheet">
	<script type="text/javascript" src="jsibox/jsibox_basic.js"></script>
</head>

<body>
<h1>Quick Planes Battle</h1>
<h2>QA Report</h2>

<p>Тестирование производилось на следующих устройствах:</p>

<ul>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="ramos_cpuz_info">
		<label for="ramos_cpuz_info">Планшет Ramos W17Pro (7", Android 4.0.3), 1024x600</label>
			<div class="spoiler_body">
				<a href="ramos/cpuz1.png" rel="ramos_cpuz" onclick="return jsiBoxOpen(this)"> <img src="ramos/cpuz1.png" width="200" > </a>
				<a href="ramos/cpuz2.png" rel="ramos_cpuz" onclick="return jsiBoxOpen(this)"> <img src="ramos/cpuz2.png" width="200" > </a>
				<a href="ramos/cpuz3.png" rel="ramos_cpuz" onclick="return jsiBoxOpen(this)"> <img src="ramos/cpuz3.png" width="200" > </a>
			</div>
		</div>
	</li>

	<br>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="g700_cpuz_info">
		<label for="g700_cpuz_info">Телефон Huawei G700 (5", Android 4.2.1, 1280x720)</label>
			<div class="spoiler_body">
				<a href="g700/cpuz1.png" rel="g700_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g700/cpuz1.png" width="200" > </a>
				<a href="g700/cpuz2.png" rel="g700_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g700/cpuz2.png" width="200" > </a>
				<a href="g700/cpuz3.png" rel="g700_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g700/cpuz3.png" width="200" > </a>
			</div>
		</div>
	</li>

	<br>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="g600_cpuz_info">
		<label for="g600_cpuz_info">Телефон Huawei G600 (4.5", Android 4.0.4, 960x540)</label>
			<div class="spoiler_body">
				<a href="g600/cpuz1.png" rel="g600_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g600/cpuz1.png" width="200" > </a>
				<a href="g600/cpuz2.png" rel="g600_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g600/cpuz2.png" width="200" > </a>
				<a href="g600/cpuz3.png" rel="g600_cpuz" onclick="return jsiBoxOpen(this)"> <img src="g600/cpuz3.png" width="200" > </a>
			</div>
		</div>
	</li>

	<br>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="p8_cpuz_info">
		<label for="p8_cpuz_info">Телефон Huawei P8 Lite (5.0", Android 5.0, 1280x720)</label>
			<div class="spoiler_body">
				<a href="p8/cpuz1.png" rel="p8_cpuz" onclick="return jsiBoxOpen(this)"> <img src="p8/cpuz1.png" width="200" > </a>
				<a href="p8/cpuz2.png" rel="p8_cpuz" onclick="return jsiBoxOpen(this)"> <img src="p8/cpuz2.png" width="200" > </a>
				<a href="p8/cpuz3.png" rel="p8_cpuz" onclick="return jsiBoxOpen(this)"> <img src="p8/cpuz3.png" width="200" > </a>
				<a href="p8/cpuz4.png" rel="p8_cpuz" onclick="return jsiBoxOpen(this)"> <img src="p8/cpuz4.png" width="200" > </a>
			</div>
		</div>
	</li>

	<br>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="philips_cpuz_info">
		<label for="philips_cpuz_info">Телефон Philips W6500 (4.3", Android 4.0.4, 960x540)</label>
			<div class="spoiler_body">
				<a href="philips/cpuz1.png" rel="philips_cpuz" onclick="return jsiBoxOpen(this)"> <img src="philips/cpuz1.png" width="200" > </a>
				<a href="philips/cpuz2.png" rel="philips_cpuz" onclick="return jsiBoxOpen(this)"> <img src="philips/cpuz2.png" width="200" > </a>
				<a href="philips/cpuz3.png" rel="philips_cpuz" onclick="return jsiBoxOpen(this)"> <img src="philips/cpuz3.png" width="200" > </a>
			</div>
		</div>
	</li>

	<br>
  	<li>
		<div class="spoiler">	<input type="checkbox" id="moto_cpuz_info">
		<label for="moto_cpuz_info">Телефон Motorola Moto X Play (5.5", Android 6.0.1, 1920x1080)</label>
			<div class="spoiler_body">
				<a href="moto/cpuz1.png" rel="moto_cpuz" onclick="return jsiBoxOpen(this)"> <img src="moto/cpuz1.png" width="200" > </a>
				<a href="moto/cpuz2.png" rel="moto_cpuz" onclick="return jsiBoxOpen(this)"> <img src="moto/cpuz2.png" width="200" > </a>
				<a href="moto/cpuz3.png" rel="moto_cpuz" onclick="return jsiBoxOpen(this)"> <img src="moto/cpuz3.png" width="200" > </a>
			</div>
		</div>
	</li>

</ul>
<p>Также я попытался установить игру на старенький телефон HTC Wildfire S c Android 2.3 и экраном в 2.5", 
однако попытка не увенчалась успехом: телефон написал "Ошибка установки" и все... Но, учитывая что подобных
устройств сейчас уже практически не существует, это нельзя назвать каким-то серьезным недостатком. Поэтому 
в дальнейшем тестировании данный аппарат не участвовал. </p>
<br>


<h2>Обнаруженные проблемы</h2>
<p>
В целом, тестирование прошло без каких-либо неприятных неожиданностей и серьезных багов геймплея и реализации. На всех
тестируемых устройствах игра устанавливается без всяких проблем и работает с достаточной производительностью. 
Хотя реальный FPS и не замерялся, замечаний на какие-либо подтормаживания в процессе игры нет. Те подтормаживания,
которые видны на видео обусловлены тормозами самой записывающей программы - если запись не
включается, то тормозов никаких нет. Ни на одном из 
устройств также не было замечено каких-либо графических атефактов связанных с различным разрешением экрана, 
неправильной загрузкой текстур и т.д. - картинка качественная.
</p>

<p>
Сама игра получилась довольно интересной. Время прохождения уровней варировалось у разных игроков, от уровня
к уровню, но в общем, как мне кажется, в плане играбельности задумка игры удачная: короткие уровни, которые 
можно переигрывать по много раз, в игру очень удобно играть в "свободную минутку", она не "напрягает" и не наскучивает
однообразным прохождением. Очень понравилась "физика" самолетов: для аркадной игры она просто идеальна.
Есть конечно и небольшие пожелания по улучшению геймплея, но о них - ниже.	
</p>

<p>
В игру играли 5 человек, независимо друг от друга. Возраст - от 6 до 36 лет. Каждый из них, записывал свои замечания,
найденные баги и пожелания по улучшению геймплея. Какие-то из этих багов уже были исправлены в процессе тестирования,
какие-то возможно не баги а "feature", в общем так или иначе я попытался систематизировать все замечания в таблицу.
</p>

<br>

<table border=1 width=100% cellpadding=10>
	<tr> <th>Баг</th>	<th>Примечание</th>	</tr>	

	<tr> 
		<td>
			На экране выбора самолета кнопка перехода к следующему экрану явно лишняя. Вообще у двух этих
			маленьких кнопок такой вид, как будто они предназначены для выбора самолета (крутить карусельку).
			<b>Все без исключения</b> игроки первый раз пытались перейти на следующий экран просто тыча пальцем 
			в сам самолет. Даже после прохождения 
			некоторого количества уровней, эта тенденция не изменялась и кнопка перехода к экрану выбора уровня
			вызывала явное раздражение игроков. Достаточно оставить только кнопку возврата к предыдущему экрану.
		</td>	
		<td>
			<a href="common/next_button.png" rel="next_btn" onclick="return jsiBoxOpen(this)"> <img src="common/next_button.png" width="300" > </a>
		</td>
	</tr>	

	<tr bgcolor=#AEA> 
		<td >
			После прохождения второго уровня не открываются новые самолеты.
		</td>	
		<td>
			Исправлено.
		</td>
	</tr>	

	<tr bgcolor=#AEA> 
		<td >
			В игровом меню кнопка "Restart" перезапускает всегда первый уровень.
		</td>	
		<td>
			Исправлено.
		</td>
	</tr>	
	
	<tr> 
		<td>
			После уровней, при прохождении которых становится доступен следующий самолет, при возврате на экран
			выбора самолета с экрана выбора уровня, новый самолет доступен, а надпись гласит об обратном:
			"This plane is closed so far..." и т.д. 
			Если выйти из игры, а потом зайти, в этом случае все отображается правильно
		</td>	
		<td>
			<a href="common/new_plane.png" rel="new_plane" onclick="return jsiBoxOpen(this)"> <img src="common/new_plane.png" width="300" > </a>
		</td>
	</tr>	

	<tr bgcolor=#AEA> 
		<td >
			После проигрыша на уровне, игра выходит в стартовый экран вместо экрана выбора уровней. Очень неудобно если 
			приходится по много раз переигрывать один уровень.
		</td>	
		<td>
			Исправлено.
		</td>
	</tr>	

	<tr> 
		<td>
			Звук нажатия кнопок иногда звучит несколько раз и звук часто очень сильно отстает от обработчика - клик
			раздается частенько уже на следующем экране. То ли это из-за того что кнопка все-таки
			нажимается несколько раз (что-то типа дребезга контактов), то ли что-то не так с обработчиком
			событий кнопки, то ли это из-за того, что телефон все-таки малость подтормаживает (на некоторых
			устройствах эффект не так заметен, как на других) - неизвестно. С кнопками вообще связано несколько
			интересных багов - смотри ниже.
			UPD: Похоже, что этот эффект все-таки НЕ из-за подтормаживаний телефона: даже на самом быстром устройстве
			не было выявлено какой-то зависимости от загрузки процессора. Эффект лучше всего проявляется при
			очень легком касании кнопки на экране - как будто событие нажатия обрабатывается несколько раз.
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/bzJQjqgU8O0" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>	

	<tr> 
		<td>
			Стандартная андроидная кнопка "Back", как и положено по умолчанию в Android, убивает игру (закрывает Activity).
			В игре следует перехватывать нажатие этой кнопки и обрабатывать ее нажатие переходом на предыдущий
			экран (Из игры - на экран выбора уровня, из экрана выбора уровня - на экран выбора самолета и т.д.).
			Выход из игры кнопкой "Back" может производится только из самого первого экрана и, желательно, с подтверждением.  
		</td>	
		<td>
			<a href="common/back_button.png" rel="back_button" onclick="return jsiBoxOpen(this)"> <img src="common/back_button.png" width="300" > </a>
		</td>
	</tr>	

	<tr> 
		<td>
			Если самолет погибает из-за того, что его подбил вражеский самолет - количество "здоровья" все равно 
			остается "1". При врезании в землю такого не происходит - в этом случае все нормально, "здоровье" обнуляется.
		</td>	
		<td>
			<a href="common/after_kill.png" rel="after_kill" onclick="return jsiBoxOpen(this)"> <img src="common/after_kill.png" width="300" > </a>
		</td>
	</tr>	

	<tr> 
		<td>
			Когда игрок проиграл уровень (его подбили или врезался в землю), проигрывается звук, символизирующий
			поражение. Так вот этот звук накладывается на весьма бодренькую мелодию самого боя и теряется на ее фоне.
			То же самое касается и других звуков (например звук, когда игрок ловит какой-нибудь бонус), но их громкость 
			не так критична. Но вот именно звук поражения должен звучать почти в тишине. То есть основная мелодия
			должна приглушаться и уступать место звуку поражения. Сейчас же это больше похоже на какой-то шум. 
			То же самое касается и победных фанфар.
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/lc3O-nneecs" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>	

	<tr> 
		<td>
			Если во время игры поступает входящий звонок, или просто нажать на кнопку "Home", или заблокировать
			телефон, или по какой-то другой
			причине Activity игры теряет фокус, игра ставится на паузу, но при возврате в игру игрок сразу попадает 
			"в бой". Лучше будет, если в такой ситуации, возвращаясь в игру будет открыто игровое меню и у игрока будет 
			возможность подготовится к бою, и самому нажать кнопку "продолжить".
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/g0fgaw7taVY" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>	

	<tr> 
		<td>
			Кнопка включения/выключения звука имеет забавный баг: если нажать на нее пальцем, оттянуть палец в сторону
			и отпустить, то кнопка переключит свое изображение с "вкл" на "выкл" или наоборот, но на звуке это
			никак не отразится :). Видимо перерисовка кнопки происходит при реакции на нажатие, а непосредственно
			управление звуком - при реакции на отпускание. Точно такой же эффект и с кнопкой стрельбы в игре:
			если провести с ней такие же манипуляции, то самолет непрерывно сам стреляет. Этакий "Caps Lock" 
			для стрельбы :)
			На всех других кнопках такого замечено не было.
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/MOgkbhFxD90" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>	

	<tr> 
		<td>
			Музыка в меню "стартует" только в первом экране. Если после первого экрана переходить в экран выбора
			самолета, экран выбора уровня и обратно, то все нормально. Если же выходишь из игрового экрана после
			поражения или победы в экран выбора уровня - музыка меню не играет.
	
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/QzbUN7QAwlw" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>

	<tr> 
		<td>
			Не забудьте поправить надпись под иконкой :)
		</td>	
		<td>
			<a href="common/icon_label.png" rel="icon_label" onclick="return jsiBoxOpen(this)"> <img src="common/icon_label.png" width="100" > </a>
		</td>
	</tr>	
		
	<tr> 
		<td>
			Вроде бы и не баг, как таковой, но неприятная ситуация. При подлете к углу экрана под определенным углом
			самолет разворачивается на 180 градусов относительно верхней границы и летит вниз.
			Плохо то, что в этот момент он почти весь остается вне поля видимости - видна только часть стойки шасси.
			И, хотя он при этом остается управляемым, это вносит некоторую растерянность в ответственные моменты боя.
			Сама идея с разворотом на 180 при пересечении границы мне очень нравится, но наверное лучше сделать так, 
			чтобы вот в таких случаях, как на видео (когда он под острым углом залетает к границе, или даже просто
			находится близко к земле и пересекает границу) разворачивать его не на 180 градусов, а направлять просто к центру экрана,
			таким образом, гарантированно уберегать его от падения за пределами видимости.
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/HGOkKCDF2ZU" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>

	<tr> 
		<td>
			Если случайно до взлета на старте нажать кнопку управления самолетом - это приводит к неминуемому взрыву
			сразу на старте. Это явно неправильно. 
		</td>	
		<td>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/4qeq2JdpmN4" frameborder="0" allowfullscreen></iframe>
		</td>
	</tr>

</table>

<br><br>
<h2>Замечания, пожелания, улучшения...</h2>
<p> Далее следует список замечаний и предложений, высказываемых игроками в процессе тестирования.
 Собственно, замечания не являются багами, но вызывали в процессе игры некоторые неудобства или сложности с освоением.
<ul>
	<li>
	Стоит сделать некий мини-туториал или поясняющие подсказки при первом запуске, как управлять самолетом. 
	Это был самый первый вопрос: "Как же эта чертова штука управляется?!". Кнопки управления 
	сливаются с фоном и при первом запуске никто вообще не обратил на них внимания! Как вариант, можно сделать 
	кнопки поярче (хотя бы при первых запусках), но лучше именно мини-туториал.
	</li>
	<br>
	<li>
	Саму кнопку выстрела в принципе можно совсем убрать. Сделать так , что просто тап по правой половине экрана
	это и будет выстрел. Сейчас иногда промахиваешься в процессе боя мимо кнопки и это очень раздражает. Ну или 
	хотя бы сделать эту кнопку крупнее - чтобы не промахиваться по ней :)
	</li>
	<br>
	<li>
	Поначалу вызывает много вопросов периодичность выстрелов самолета. Нигде не объясняется, что самолету требуется
	некоторое время на "перезарядку". Это очень обескураживает: пристроился в хвост для атаки, нажимаешь кнопку выстрела - 
	и ничего не происходит. Сразу и не поймешь - это игра тормозит, или сам мимо кнопки нажал, или еще что... Хорошим решением
	будет какой-то индикатор рядом с индикатором здоровья, например в виде обоймы: сразу будет видно и сколько снарядов
	за один раз выпускает самолет, и можно анимировать его, как в него "заряжаются патроны".
	</li>
	<br>
	<li>
	Очень хочется видеть полоски "здоровья" противников. Даже не так. Вот так: ОЧЕНЬ-ОЧЕНЬ хочется видеть полоски "здоровья" противников.
	Особенно на более сложных уровнях иногда возникает ощущение
	что враги бессмертные: стреляешь в них, стреляешь, а умирают они все равно внезапно :) 
	Небольшие полоски здоровья у врагов будут очень полезны. Как вариант, можно сделать чтобы 
	у самолетов при уменьшении "здоровья" шел дым. Чем меньше осталось здоровья - тем больше/чернее валит дым.
	</li>
	<br>	
	<li>
	Сделать возможность отключать музыку и звуки раздельно. В игре звуки несут смысловую нагрузку - слышно когда по тебе
	стреляют, слышно когда взяли бонус и т.д. их отключать обычно нежелательно. 
	А вот насчет музыки мнения кардинально разошлись: кому-то она очень нравится, а кому-то кажется
	надоедливой (а отключить ее отдельно от звуков нельзя). 
	</li>
	<br>
	<li>
	После победы на уровне, за которую становится доступным новый самолет - это радостное событие надо как-то отмечать. 
	Возможно, выходить не в меню выбора уровня, а в меню выбора самолета. Или сделать какую-то анимацию открытия
	(как, например, с замком после покупки). Или как-то по-другому, 
	но показывать это надо обязательно: игрок получил награду, а она проходит незамеченной. 
	</li>
	<br>
	<li>
	Надо как-то сделать подсказки по бонусам в игре. Ума не приложу, как лучше, но надо. Возможно, просто 
	перерисовать их по-крупнее: сейчас они мелковаты, не сразу разберешь что там на них нарисовано. Но лучше, наверно,
	сделать какой-то еще экран, где просто описать каждый бонус - что он улучшает. 	
	</li>
	<br>
	<li>
	На что еще следует обратить внимание - это экран загрузки - если требуется отображать проценты, то хотелось бы чтобы 
они "набирались" более равномерно. Понятно, что ресурсы в игре грузятся определенными "порциями", и если нельзя
осуществить более "равномерную" по скорости загрузку ресурсов, то может быть следует отображать прогресс загрузки вообще
без привязки к процентам (например просто надпись "Loading.." или что-то аналогичное). А сами подсказки 
(которые а-ля "tip of the day") можно сделать покрупнее и показывать не все за один раз, а при разных запусках разные.
	</li>
</ul>	
</p>

<h2>Покупка</h2>
<p>
Что касаемо покупки уровней, то ничего необычного больше замечено не было. Все нюансы были устранены в процессе тестирования.
Покупка со второго аккаунта на обновленной версии прошла "без сучка и задоринки". На разных устройствах с одним аккаунтом
также все открылось как надо. 
</p>
<p>
Думаю, что можно сделать доступной покупку самолетов. Например какой-то самолет можно
получить выиграв определенный уровень, а можно, если уровень никак не получается пройти, просто купить его и, 
"ввалить" всем врагам. Только нужно сделать так, чтобы сразу самый сильный самолет купить было нельзя, а 
чтобы каждый следующий самолет становился бы доступным для покупки после прохождения определенного уровня.
</p>

<h2>Сложность уровней</h2>
<p>
Сложным был второй уровень. Сейчас, после исправления, сложность всех уровней я бы сказал, оптимальная. И самолеты 
по силе подобраны хорошо и соответствуют уровням. В общем, в этом плане все нормально.
</p>



<h2>Screenshots:</h2>
<p>
Ну и напоследок немного скриншотов с разных устройств: возможно глаз разработчика заметит что-то, что скрылось от глаз 
тестеров.
</p>


<br>
<br>

<a href="common/scr1.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr1.png" width="300" > </a>
<a href="common/scr2.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr2.png" width="300" > </a>
<a href="common/scr3.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr3.png" width="300" > </a>
<a href="common/scr4.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr4.png" width="300" > </a>
<a href="common/scr5.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr5.png" width="300" > </a>
<a href="common/scr6.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr6.png" width="300" > </a>
<a href="common/scr7.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr7.png" width="300" > </a>
<a href="common/scr8.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr8.png" width="300" > </a>
<a href="common/scr9.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr9.png" width="300" > </a>
<a href="common/scr10.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr10.png" width="300" > </a>
<a href="common/scr11.png" rel="screens" onclick="return jsiBoxOpen(this)"> <img src="common/scr11.png" width="300" > </a>




</body>
</html>
